import 'package:flutter/material.dart';

class Connection extends StatefulWidget {
  final Function? onSubmit;
  final Function? onDissmiss;
  final Color buttonColor;

  const Connection({Key? key, this.onSubmit, this.onDissmiss, required this.buttonColor}) : super(key: key);
  @override
  _Connection createState() => _Connection();
}

class _Connection extends State<Connection> {
  @override
  void dispose() async {
    super.dispose();
    if (widget.onDissmiss != null) {
      await widget.onDissmiss!();
    }
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: Column(
        mainAxisAlignment: MainAxisAlignment.center,
        crossAxisAlignment: CrossAxisAlignment.center,
        children: [
          SizedBox(
            width: MediaQuery.of(context).size.width * 1,
            height: 230,
            // color: Colors.white,
            child: Padding(
              padding: const EdgeInsets.only(top: 50),
              child: Image.asset('packages/request_api_helper/assets/image/plug/plug.png'),
            ),
          ),
          const SizedBox(
            height: 20,
          ),
          Center(
            child: Text(
              'CONNECTION LOST',
              style: Theme.of(context).textTheme.headline1 ?? const TextStyle(color: Colors.black, fontSize: 20, fontWeight: FontWeight.w700),
            ),
          ),
          const SizedBox(
            height: 20,
          ),
          Center(
            child: Text(
              'Check Your Internet Connection',
              style: Theme.of(context).textTheme.caption ??
                  const TextStyle(
                    color: Colors.white,
                    fontSize: 14,
                  ),
            ),
          ),
          const SizedBox(
            height: 80,
          ),
          ElevatedButton(
            onPressed: () async {
              Navigator.pop(context);
              if (widget.onSubmit != null) {
                await widget.onSubmit!();
              }
            },
            style: ElevatedButton.styleFrom(
              padding: const EdgeInsets.symmetric(vertical: 8.0, horizontal: 20),
              shape: RoundedRectangleBorder(
                borderRadius: BorderRadius.circular(18.0),
              ),
              primary: widget.buttonColor,
              textStyle: Theme.of(context).textTheme.button ??
                  const TextStyle(
                    color: Colors.white,
                  ),
            ),
            child: const Text(
              '             Reconnect            ',
              style: TextStyle(fontSize: 16),
            ),
          )
        ],
      ),
    );
  }
}

class Timeout extends StatefulWidget {
  final Function? onSubmit;
  final Function? onDissmiss;
  final Color buttonColor;

  const Timeout({Key? key, this.onSubmit, this.onDissmiss, required this.buttonColor}) : super(key: key);
  @override
  _Timeout createState() => _Timeout();
}

class _Timeout extends State<Timeout> {
  @override
  void dispose() async {
    super.dispose();
    if (widget.onDissmiss != null) {
      await widget.onDissmiss!();
    }
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: Column(
        mainAxisAlignment: MainAxisAlignment.center,
        crossAxisAlignment: CrossAxisAlignment.center,
        children: [
          SizedBox(
            width: MediaQuery.of(context).size.width * 1,
            height: 230,
            // color: Colors.white,
            child: Padding(
              padding: const EdgeInsets.only(top: 50),
              child: Image.asset('packages/request_api_helper/assets/image/worldwide/worldwide.png'),
            ),
          ),
          const SizedBox(
            height: 20,
          ),
          Center(
            child: Text(
              'REQUEST TIMEOUT',
              style: Theme.of(context).textTheme.headline1 ?? const TextStyle(color: Colors.black, fontSize: 20, fontWeight: FontWeight.w700),
            ),
          ),
          const SizedBox(
            height: 20,
          ),
          Center(
            child: Text(
              'Maybe Server Is Down',
              style: Theme.of(context).textTheme.caption ??
                  const TextStyle(
                    color: Colors.black38,
                    fontSize: 14,
                  ),
            ),
          ),
          const SizedBox(
            height: 80,
          ),
          ElevatedButton(
            onPressed: () async {
              Navigator.pop(context);
              if (widget.onSubmit != null) {
                await widget.onSubmit!();
              }
            },
            style: ElevatedButton.styleFrom(
              padding: const EdgeInsets.symmetric(vertical: 8.0, horizontal: 20),
              shape: RoundedRectangleBorder(
                borderRadius: BorderRadius.circular(18.0),
              ),
              primary: widget.buttonColor,
              textStyle: Theme.of(context).textTheme.button ??
                  const TextStyle(
                    color: Colors.white,
                  ),
            ),
            child: const Text(
              '             Back            ',
              style: TextStyle(fontSize: 16),
            ),
          )
        ],
      ),
    );
  }
}
